<template>
  <li class="nav-toggle" v-if="currentRoom.name">
    <span class="toggle-title">{{currentRoom.name}}</span>
    <ul v-for="(item, index) in toggle_menu_items"
        :key="index">
      <a href="#" class="nav-link" :id=item.name v-on:click="toggle"
         :style="toggleButtonStyle(selectedItem === item.name,item)">
        {{ item.name }}
      </a>
    </ul>
  </li>
</template>

<script>
export default {
  name: 'ToggleButton',
  props: {
    options: {
      type: Object,
      required: false
    },
    value: {
      type: String,
      required: false
    },
    name: {
      type: String,
      required: false
    },
    group: {
      type: String,
      required: false,
      default: ''
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    }
  },

  methods: {
    toggle(event) {
      var clickedItem = event.target.id.replace(this.group, '')

      var disabled = false
      console.error(clickedItem)
      if (clickedItem != this.selectedItem) {
        this.defaultOptions.config.items.forEach(item => {
          if (item.name == clickedItem) {

            // check if item is disabled in config
            disabled = item.disabled

            if (!disabled) {
              // create function from str and run it
              //NOTE: may be unsecure
              if (Object.keys(this.currentRoom).includes(item.id)) {
                window.location.href = this.currentRoom[item.id]
              }
            }
          }
        });

        if (!disabled) {
          this.selectedItem = clickedItem
          this.selected = true
          console.log("rps header: ToggleButton selectedItem",this.selectedItem)
          this.$emit('selected', this.selected)
          this.$emit('input', this.selectedItem)
          this.$emit('change', {
            value: event.target.id.replace(this.group, ''),
            srcEvent: event
          })
        }
      }
    },

    toggleButtonStyle(selected, item) {
      if (selected) {
        if (item.selectedBackgroundColor === undefined) {
          return {
            borderBottom: '2px solid #001e50',
          }
        }
        return {
          borderBottom: '2px solid #001e50',
        }
      }
      if (item.backgroundColor === undefined) {
        return {
          backgroundColor: this.defaultOptions.layout.backgroundColor
        }
      }
      return {
        backgroundColor: item.backgroundColor
      }
    },

    getCurrentItem()
    {
      var item
      this.defaultOptions.config.items.forEach(element => {
        if (window.location.href.includes(element.triggerUrl)) {
          item = element.name
        }

      });
      return item
    },

    getCurrentRoom()
    {
      var room = 'not found'
      var charCount = 0
      this.defaultOptions.config.rooms.forEach(element => {
        var keys = Object.keys(element);
        for (var i = 0; i <  keys.length; i++) {
          var toggle_menu_item = element[keys[i]];
          console.log("rps header: ToggleButton toggle_menu_item", toggle_menu_item)

          if (window.location.href.includes(toggle_menu_item)) {
            console.log("rps header: ToggleButton included")
            if (toggle_menu_item.length > charCount)
            {
              charCount = toggle_menu_item.length
              room = element
            }
          }
          }
        });
      return room
    },

    observeUrlChange(){
      console.log("rps header: ToggleButton observeUrlChange")
      let oldHref = document.location.href;
      const body = document.querySelector("body");
      const observer = new MutationObserver(mutations => {
        if (oldHref !== document.location.href) {

          oldHref = document.location.href;
          
          this.currentRoom = this.getCurrentRoom()
          this.CurrentItem = this.getCurrentItem()

          console.log("rps header: ToggleButton toggle, room and item", this.currentRoom, this.CurrentItem)
          if (!this.currentRoom || !this.CurrentItem)
          {
            this.toggle_menu_items = []
            return;
          }

          var toggle_menu_items = this.defaultOptions.config.items.filter(item => {
            return Object.keys(this.currentRoom).includes(item.id)
          })
          console.log("rps header: ToggleButton toggle_menu_items", toggle_menu_items)
          if (!toggle_menu_items)
          {
            toggle_menu_items = []
          }
          this.toggle_menu_items = toggle_menu_items

          }
      });
      observer.observe(body, { childList: true, subtree: true });
    },

  },

  data() {
    console.log('rps header: ToggleButton start toggle button', this.options)
    if (this.options !== undefined) {
      this.defaultOptions = this.options
    }
    
    var room = this.getCurrentRoom()
    var item = this.getCurrentItem()

    console.log("rps header: ToggleButton toggle, room and item", room, item)
    if (!room || !item)
    {
      return {
        selectedItem: 'unknown',
        currentRoom: 'unknown',
        toggle_menu_items: [],
      }
    }

    var toggle_menu_items = this.defaultOptions.config.items.filter(item => {
      return Object.keys(room).includes(item.id)
    })
    console.log("rps header: ToggleButton toggle_menu_items", toggle_menu_items)
    if (!toggle_menu_items)
    {
      toggle_menu_items = []
    }

    return {
      selectedItem: item,
      currentRoom: room,
      toggle_menu_items: toggle_menu_items,
    }
  },

  watch: {
    value(val) {
      //console.log("rps header: ToggleButton watch val", val)
      this.selectedItem = val
    },
  },

  computed: {},
  mounted() {
    if (this.options !== undefined) {
      this.defaultOptions = this.options
    }

    this.observeUrlChange();
  },
  created() {
    this.defaultOptions = {
      layout: {
        backgroundColor: 'lightgray',
        selectedBackgroundColor: 'lightgray',
      },
      config: {
        delay: 0.4,
        preSelected: 'unknown',
        disabled: false,
        items: [
          {
            name: 'Forum',
            selectedBackgroundColor: 'yellow',
          },
          {
            name: 'Cloud',
            selectedBackgroundColor: 'blue',
          },
        ]
      }
    }
    if (this.options !== undefined) {
      this.defaultOptions = this.options
    }
  },
}
</script>

<style lang="scss" scoped>


$textColor: #cec7c7;
$fontSize: 13px;

#rps-header.rps-header {
  .rps-header-container {
    .mobile-nav-toggle {

      ul {
        li {
          display: inline-flex;
          padding-top: 30px !important;
          padding-right: 20px;

          ul {
            margin-left: 6px;

            .nav-link {
              font-weight: 500 !important;
              font-size: $fontSize !important;
              top: 5px !important;
              padding-bottom: 2px !important;
              cursor: pointer;

              &:after {
                bottom: -2px !important;
              }
            }
          }

          .toggle-title {
            font-size: $fontSize !important;
            color: $textColor !important;
            padding-right: 5px;
            padding-top: 2px;
          }
        }
      }
    }

    .nav-menu {
      .nav-toggle {
        display: flex !important;
        height: 10px;
        line-height: 0px;
        justify-content: end !important;
        padding-right: 10px;
        margin-top: 0px;
        padding-left: 0px;

        .drop-menu {
          z-index: 99999 !important;
        }

        .nav-link {
          font-weight: 500 !important;
          font-size: $fontSize !important;
          top: 5px !important;
          padding-bottom: 2px !important;
          margin-left: 5px;
          margin-right: 5px;
          cursor: pointer;

          &:after {
            bottom: -2px !important;
          }
        }

        .toggle-title {
          font-size: $fontSize !important;
          color: $textColor !important;
          padding-right: 10px;
        }
      }
    }
  }
}
</style>
